<?php
// Version: 1.0: DoublePostStopper.php

if (!defined('SMF'))
	die('Hacking attempt...');

function double_post_load_theme()
{
	global $context, $options, $topic, $txt;

	loadLanguage('DoublePostStopper');

	// I'm lazy.

	if (!empty($topic) && double_post_check())
	{
		if (!isset($_REQUEST['msg']) && ($context['current_action'] == 'post' || $context['current_action'] == 'post2'))
			fatal_error($txt['double_post_attempt'], false); // You naughty, naughty person!
		if (empty($context['current_action']))
			$options['display_quick_reply'] = 0; // Disable quick reply; no sense giving that to the user if they can't use it.
	}
}
function double_post_check()
{
	global $context, $smcFunc, $topic, $modSettings, $txt, $user_info;

	$result = $smcFunc['db_query']('', '
		SELECT
			t.id_member_started, m.id_member, m.poster_time, m.poster_name, m.poster_email
		FROM {db_prefix}topics AS t
			INNER JOIN {db_prefix}messages AS m ON (t.id_last_msg = m.id_msg)
		WHERE t.id_topic = {int:topic}
		LIMIT 1',
		array(
			'topic' => $topic
		)
	);
	$bumpAttempt = false;
	$row = $smcFunc['db_fetch_assoc']($result); // we can assume this exists because if no topic, we wouldn't be here, and if the topic's missing its id_last_msg, we're kinda screwed anyway
	$smcFunc['db_free_result']($result);

	// Can you do this?
	if (allowedTo('doublePost_' . ($user_info['id'] == $row['id_member_started'] ? 'own' : 'any')))
		return false;

	if (!empty($modSettings['doublePostAdmin_main']))
	{
		$timeTHold = $modSettings['doublePostAdmin_main'] * 60 * 60 * 24;
		if ($row['poster_time'] + $timeTHold > time())
			$bumpAttempt = true;
	}

	// So, is the last message ours?
	if ($bumpAttempt && (($user_info['id'] > 0 && $row['id_member'] == $user_info['id']) || (isset($_POST['guestname']) && $_POST['guestname'] == $row['poster_name']) || (isset($_POST['email']) && $_POST['email'] == $row['poster_email'])))
		return true;

	return false;
}

function double_post_general_mod_settings(&$config_vars)
{
	global $txt;

	$config_vars = array_merge($config_vars, array(
		'',
		array('int', 'doublePostAdmin_main', 'postinput' => $txt['manageposts_days'], 'subtext' => $txt['doublePostAdmin_sub']),
	));
}

function double_post_load_permissions(&$permissionGroups, &$permissionList, &$leftPermissionGroups, &$hiddenPermissions, &$relabelPermissions)
{
	$permissionList['board'] += array(
		'doublePost' => array(true, 'post', 'participate'),
	);
}

?>